/*
 * *************************************************
 * Copyright (c) 2019 QMTH. All Rights Reserved.
 * Created by Deason on 2019-05-05 15:18:42.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.print.config;

import cn.com.qmth.examcloud.api.commons.security.bean.AccessApp;
import cn.com.qmth.examcloud.api.commons.security.bean.User;
import cn.com.qmth.examcloud.support.cache.CacheHelper;
import cn.com.qmth.examcloud.support.cache.bean.AppCacheBean;
import cn.com.qmth.examcloud.web.redis.RedisClient;
import cn.com.qmth.examcloud.web.security.ResourceManager;
import cn.com.qmth.examcloud.web.support.ApiInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class ExamCloudResourceManager implements ResourceManager {
    @Autowired
    private RedisClient redisClient;

    @Override
    public AccessApp getAccessApp(Long appId) {
        AppCacheBean appCacheBean = CacheHelper.getApp(appId);
        AccessApp app = new AccessApp();
        app.setAppId(appCacheBean.getId());
        app.setAppCode(appCacheBean.getCode());
        app.setAppName(appCacheBean.getName());
        app.setSecretKey(appCacheBean.getSecretKey());
        app.setTimeRange(appCacheBean.getTimeRange());
        return app;
    }

    @Override
    public boolean isNaked(ApiInfo apiInfo, String mapping) {
        if (null == apiInfo) {
            return true;
        }

        if (null != apiInfo) {
            Integer id = apiInfo.getId();

            if (null != id) {
                if (id.equals(103)) {
                    return true;
                }
            } else {
                return true;
            }
        }

        return false;
    }

    @Override
    public boolean hasPermission(User user, ApiInfo apiInfo, String mapping) {
        return true;
    }

}