/*
 * *************************************************
 * Copyright (c) 2019 QMTH. All Rights Reserved.
 * Created by Deason on 2019-05-05 15:18:42.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.print.config;

import cn.com.qmth.examcloud.web.interceptor.FirstInterceptor;
import cn.com.qmth.examcloud.web.security.RequestPermissionInterceptor;
import cn.com.qmth.examcloud.web.security.ResourceManager;
import cn.com.qmth.examcloud.web.security.RpcInterceptor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

@Configuration
public class ExamCloudWebMvcConfigurer implements WebMvcConfigurer {
    @Autowired
    private ResourceManager resourceManager;

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        String[] excludes = new String[]{"/", "/init", "/doc.html"};
        registry.addInterceptor(new FirstInterceptor()).addPathPatterns("/api/**").excludePathPatterns(excludes);
        registry.addInterceptor(new RpcInterceptor()).addPathPatterns("/api/**").excludePathPatterns(excludes);

        RequestPermissionInterceptor permissionInterceptor = new RequestPermissionInterceptor(resourceManager);
        registry.addInterceptor(permissionInterceptor).addPathPatterns("/api/**").excludePathPatterns(excludes);
    }

    @Override
    public void addCorsMappings(CorsRegistry registry) {
        registry.addMapping("/**")
                .allowedOrigins("*")
                .allowCredentials(false)
                .allowedMethods("POST")
                .maxAge(3600);
    }

}